package jspell;

$VERSION = '0.04';

$ENV{'LC_CTYPE'} = $ENV{'LC_CTYPE'} || 'iso_8859_1';
use locale;

BEGIN{
use Exporter ();
@ISA=qw(Exporter);
@EXPORT = qw(&setstopwords &der &flags &nlgrep &nlgrep1 &nlgrep2 &nlgrep3 &rad 
   &fea &any2str &mkradtxt &jspell_dict) ;

use IPC::Open3;  # para redireccionar stdin, stdout stderr dum comando

$delim = '===';
%stop =();

chop($jspell = `which jspell`);
#$jspell = '/home/jj/bin/jspell' unless (-e $jspell );
die ("cant find jspell\n") unless (-e $jspell );

($jspelllib = $jspell) =~ s!/bin/jspell!/lib/jspell!;

chop($agrep = `which agrep`);
#$agrep = '/home/jj/bin/agrep' unless (-e $agrep );
die ("cant find agrep\n") unless (-e $agrep );

$tmp="/tmp";
}

sub jspell_dict{
  my $name= shift;
  my $pers=shift || "$ENV{HOME}/.jspell";
  $pers = "-p $pers" if $pers;

  $pid1 = open3(DW,DR,DE,
         "$jspell -d $name -a $pers -W 0 -y -o'%s!%s:%s:%s:%s'") ||
                die "cant find 'jspell' program";
  my $lixo = <DR>;                       #skip first line
}

sub flags {
  my $w = shift;
  my $old=$/;
  $/="\n";
  print DW "\$\"$w\n";
  my $a=<DR>;
  chop $a;
  my @b = split(/[# ,]+/,$a);
  $/=$old;
  @b;
}

sub der {
  my $w = shift;
  my @der = flags($w);
  my $old=$/;
  my %res=();
  my $command= sprintf("echo '%s'|$jspell -d port -e -o '' ",join("\n",@der));
  $/="\n";

  for (`$command`){chop;
           s/(=|, | $)//g;
           for(split){
           $res{$_}++;}
  }
  $/=$old;
  keys %res;
}

sub setstopwords {
  for(@_){ $stop{$_}=1;}
}

sub nlgrep {
        my $proc=shift;
        my $file_list=join(' ',@_);
        my $old=$/;
        $/="\n";

        open(TMPp,"> $tmp/_jspell$$") || die(" can't open tmp ");
        for (der($proc)) { print TMPp "$_\n" unless $stop{$_}; }
        close(TMPp);

        my @res=();
        for (`$agrep -h -i -w -f $tmp/_jspell$$ $file_list`) {
                push(@res,$_);
        }
        unlink "$tmp/_jspell$$";
        $/=$old;
        @res;
}

sub nlgrep1{
        my $proc=shift;
        my $file_list=join(' ',@_);
        my $old=$/;
        $/="\n";

        my @res=();
        for (`$agrep -h -i -w '$proc' $file_list`) {
           if( /(.*?)$delim/){ push(@res,$1) };
        }
        $/=$old;
        @res;
}

sub nlgrep3 {
        my $proc=shift;
        my $qt=shift;
        my $file_list=join(' ',@_);
        my $old=$/;
        $/="\n";

        open(TMPp,"> $tmp/_jspell$$") || die(" can't open tmp ");
        for (der($proc)) { print TMPp "$_\n" unless $stop{$_}; }
        close(TMPp);

        my @res=();
        for (`$agrep -h -i -w -f $tmp/_jspell$$ $file_list | head -$qt`) {
                push(@res,$_);
        }
        unlink "$tmp/_jspell$$";
        $/=$old;
        @res;
}

sub nlgrep2 {
        my $proc=shift;
        my $old = $/;
        my $sep=shift;
        my $file_list=join(' ',@_);
        my $a;

        open(TMPp,"> $tmp/_jspell$$") || die(" can't open tmp\n ");
        for (der($proc)) { print TMPp "$_\n" unless $stop{$_}; }
        close(TMPp);

        my @res=();
        $/=$sep;
        open(TMPp,"$agrep -d '$sep' -h -i -w -f $tmp/_jspell$$ $file_list | ") or
                die "cant agrep :-((";

        while ($a=<TMPp>){
                chomp($a);
                push(@res,$a);
        }
        $/ = $old;
        close(TMPp);
        unlink "$tmp/_jspell$$";
        @res;
}

sub rad {my $w =shift;
  if ($w =~ /\!/){return ();}
  my %rad = ();
  my $old=$/;
  $/="\n";
  print DW " $w\n";
  for ($a_=<DR>;($a_ ne "\n");$a_=<DR>){       # l^e as respostas
      chop $a_;
      %rad = ($a_ =~ m/(?: |:)([^ =:,!]+)(\!)/g ) ;
      }
  $/=$old;
  (keys %rad);
   }

sub fea{my $w =shift;
  my $old=$/;
  $/="\n";
  if ($w =~ /\!/){return ();}
  my  @r=();
  print DW " $w\n";
  my $a=<DR>;
  for (;($a ne "\n");$a=<DR>){       # l^e as respostas
    for($a){
      chop;
      my ($lixo,$clas) = /(.*?):(.*)/;
      for(split(/, /,$clas)){
        ($rad,$cla)=/(.*?)\!:*(.*):*$/;
        $cla =~ s/:+/,/g;
        my %ana = split(/[=,]/,$cla );

        if($lixo =~ /^&/) { $rad =~ s/.*?= //;
                            $ana{"unknown"} = 1 ; }
        if($rad ne "" )   { push(@r,+{"rad" => $rad, %ana});
           }}
    }}
  $/=$old;
  (@r);
}

sub any2str {
   my ($r,$i)= @_;
   my $ind = ($i >= 0)? (" " x $i) : "";
   if (ref($r) eq "HASH" )
      { "$ind {". hash2str($r,abs($i)+3) . "}" }
   elsif (ref($r) eq "ARRAY")
      { "$ind [\n" . join("\n", map (any2str($_,abs($i)+3), @$r)) . "]" }
   else {"$ind$r"}
}

sub hash2str {my($r,$i)=($_[0],$_[1]);
   my $c="";
   for(keys %$r) {$c .= "\n". any2str($_,$i). " => ". any2str($r->{$_},-$i);}
   $c;}

sub mkradtxt { my ($f1,$f2)=@_;
  open(F1,$f1) or die("cant open $f1\n");
  open(F2,"> $f2") or die("cant create $f2\n");
  while(<F1>){
    chomp;
    print F2 "$_$delim";
    while(/((\w|-)+)/g){print F2 " ",join(" ",rad($1)) unless $stop{$1}};
    print F2 "\n";
  }
  close F1;
  close F2;
}

1;
__END__

=head1 NAME

Jspell.pm - a perl module for natural language processing

=head1 SYNOPSIS

  jspell_dict(dict,[personaldict])      -> open a dictionary hash file
  der(word)             		-> list of derived words
  flags(word)           		-> list of possible roots and flags
  nlgrep(word,filename*) 		-> list of lines
  nlgrep1(agreppatt,filename*) 	        -> list of lines in pre-norm. files
  nlgrep2(word,RecSeparator,filename*) 	-> list of lines
  nlgrep3(word,N,filename*)	 	-> list up to N lines
  setstopwords(word*)	 	        -> words to be avoid in nlgrep
  rad(word)             		-> list of possible normalized words
  fea(word)             		-> list of analisis
  mkradtxt(file1,file)                  -> makes a pre-norm file of file1

=head1 DESCRIPTION

jspell.pm uses the "jspell" program in background.

You need: jspell, agrep

=head1 Example

  #!/usr/local/bin/perl

  use jspell;
  my $a;
  jspell_dict("port");

  while(<>){
    chop;
    $a= { NAME => $_,
          FLA  => [flags($_)],
          DER  => [der($_)],
          PRO  => [nlgrep($_,"/home/jj/public_html/pln/proverbio.dic")] };

    $a->{RAD}    = [rad($_)];
    $a->{JSPELL} = [fea($_)];

    print any2str($a,2);
  }

=head1 DESCRIPTION

=head2 C<jspell_dict>

Loads a dictionary (and optionally a personal dictionary).

This should be the first function to be called (before flags, der, rad, fea,
nlgrep, nlgrep2, nlgrep3; nlgrep1 is independent of jspell_dict).

   jspell_dict("port","personal.dic");
   jspell_dict("port");


=head1 AUTHOR

 J.Joao Almeida jj@di.uminho.pt

=head1 SEE ALSO

 perl(1).
 jspell(1)
 agrep(1)

=head1 BUGS

=cut
